; -=- BSMacro Core -=-
Include BSM\Core.mac

; -=- Define Program and Packages -=-
DefineProgram 586, 16, Dos, Small, 200h

; -=- Program Macro's -=-
Log_Print Macro String0, String1, String2, String3, String4
  IfNb <String0>
    Move Si, Offset String0
    Call P_Log_Print 
  EndIf
  IfNb <String1>
    Move Si, Offset String1
    Call P_Log_Print 
  EndIf
  IfNb <String2>
    Move Si, Offset String2
    Call P_Log_Print 
  EndIf
  IfNb <String3>
    Move Si, Offset String3
    Call P_Log_Print 
  EndIf
  IfNb <String4>
    Move Si, Offset String4
    Call P_Log_Print 
  EndIf
EndM
Log_PrintAndReturn Macro String
  Move Si, Offset String
  Call P_Log_Print
  Return 
EndM
Log_PrintAndJump Macro String, Label
  Move Si, Offset String
  Call P_Log_Print
  Jump Label
EndM
Log_SRAndPSIfSet Macro In, S0, S1, S2, S3, S4
  Local L0, L1, L2, L3, L4
  IfNb <S0>
   ShiftRightAndJumpIfNotCarry In, L0
    Push In
    Log_Print S0
    Pop In
   L0:
  EndIf
  IfNb <S1>
   ShiftRightAndJumpIfNotCarry In, L1
    Push In
    Log_Print S1
    Pop In
   L1:
  EndIf
  IfNb <S2>
   ShiftRightAndJumpIfNotCarry In, L2
    Push In
    Log_Print S2
    Pop In
   L2:
  EndIf
  IfNb <S3>
   ShiftRightAndJumpIfNotCarry In, L3
    Push In
    Log_Print S3
    Pop In
   L3:
  EndIf
  IfNb <S4>
   ShiftRightAndJumpIfNotCarry In, L4
    Push In
    Log_Print S4
    Pop In
   L4:
  EndIf
EndM
; -=- Program Macro's -=-

; -=- Blank Program Data -=-
StartBlankData
  Cbdb V_Temp8
  Cbdw V_Log_Handle, V_Log_BufferBytes

  ; - CpuID Level 0 -
  Cbdd V_CpuDet_MaxArg, V_CpuDet_Vendor1, V_CpuDet_Vendor2, V_CpuDet_Vendor3
  ; - CpuID Level 0 -
 
  ; - CpuID Level 1 -
  Cbdd V_CpuDet_TFMS, V_CpuDet_Feature1, V_CpuDet_Feature2
  Cbdb V_CpuDet_BrandID, V_CpuDet_CFlush, V_CpuDet_ApicID, V_CpuDet_CpuCount
  ; - CpuID Level 1 -

  ; - CpuID Level 2 -
  Cbdb V_CpuDet_ConfigCount, V_CpuDet_Config1, V_CpuDet_Config2, V_CpuDet_Config3, V_CpuDet_Config4, V_CpuDet_Config5, V_CpuDet_Config6, V_CpuDet_Config7, V_CpuDet_Config8, V_CpuDet_Config9
  Cbdb V_CpuDet_ConfigB, V_CpuDet_ConfigC, V_CpuDet_ConfigD, V_CpuDet_ConfigE, V_CpuDet_ConfigF, V_CpuDet_ConfigA
  ; - CpuID Level 2 -

  ; - CpuID Level 3 -
  Cbdd V_CpuDet_Serial1, V_CpuDet_Serial2, V_CpuDet_Serial3, V_CpuDet_Serial4
  ; - CpuID Level 3 -

  ; - CpuID Level 4 -
  Cbdd V_CpuDet_CacheConfig1, V_CpuDet_CacheConfig2, V_CpuDet_CacheConfig3, V_CpuDet_CacheConfig4
  ; - CpuID Level 4 -

  ; - CpuID Level 5 -
  Cbdd V_CpuDet_MonInfo1, V_CpuDet_MonInfo2, V_CpuDet_MonInfo3, V_CpuDet_MonInfo4 
  ; - CpuID Level 5 -

  ; - CpuID Level 6 -
  Cbdd V_CpuDet_Power1, V_CpuDet_Power2, V_CpuDet_Power3
  ; - CpuID Level 6 -

  ; - CpuID Level 80000000 -
  Cbdd V_CpuDet_ExtMaxArg, V_CpuDet_ExtVendor1, V_CpuDet_ExtVendor2, V_CpuDet_ExtVendor3
  ; - CpuID Level 80000000 -

  ; - CpuID Level 80000001 -
  Cbdd V_CpuDet_ExtFMS, V_CpuDet_ExtBrandID, V_CpuDet_ExtFeature1, V_CpuDet_ExtFeature2
  ; - CpuID Level 80000001 -

  ; - CpuID Level 80000002/3/4 -
  Cbdd V_CpuDet_ExtCpuName1, V_CpuDet_ExtCpuName2, V_CpuDet_ExtCpuName3, V_CpuDet_ExtCpuName4, V_CpuDet_ExtCpuName5, V_CpuDet_ExtCpuName6, V_CpuDet_ExtCpuName7, V_CpuDet_ExtCpuName8, V_CpuDet_ExtCpuName9, V_CpuDet_ExtCpuNameA
  Cbdd V_CpuDet_ExtCpuNameB, V_CpuDet_ExtCpuNameC
  ; - CpuID Level 80000002/3/4 -

  ; - CpuID Level 80000005 -
  Cbdb V_CpuDet_ExtL1DTLB_A1, V_CpuDet_ExtL1DTLB_E1, V_CpuDet_ExtL1CTLB_A1, V_CpuDet_ExtL1CTLB_E1, V_CpuDet_ExtL1DTLB_A2, V_CpuDet_ExtL1DTLB_E2, V_CpuDet_ExtL1CTLB_A2, V_CpuDet_ExtL1CTLB_E2, V_CpuDet_ExtL1DC_Size, V_CpuDet_ExtL1DC_A
  Cbdb V_CpuDet_ExtL1CC_Size, V_CpuDet_ExtL1CC_A, V_CpuDet_ExtL1CC_LPT, V_CpuDet_ExtL1CC_LS, V_CpuDet_ExtL1DC_LPT, V_CpuDet_ExtL1DC_LS
  ; - CpuID Level 80000005 -

  ; - CpuID Level 80000006 -
  Cbdb V_CpuDet_ExtL2DTLB_A1, V_CpuDet_ExtL2DTLB_E1, V_CpuDet_ExtL2CTLB_A1, V_CpuDet_ExtL2CTLB_E1, V_CpuDet_ExtL2DTLB_A2, V_CpuDet_ExtL2DTLB_E2, V_CpuDet_ExtL2CTLB_A2, V_CpuDet_ExtL2CTLB_E2, V_CpuDet_ExtL2C_Size, V_CpuDet_ExtL2C_A
  Cbdb V_CpuDet_ExtL2C_LPT, V_CpuDet_ExtL2C_LS
  ; - CpuID Level 80000006 -

  ; - CpuID Level 80000007 -
  Cbdd V_CpuDet_ExtEPM
  ; - CpuID Level 80000007 -

  ; - CpuID Level 80000008 -
  Cbdd V_CpuDet_ExtAddressSize, V_CpuDet_ExtProcessorCount
  ; - CpuID Level 80000008 -

  ; - CpuID Level 80000009 -
  Cbdd V_CpuDet_ExtRevisionPresence, V_CpuDet_ExtAddressSpace, V_CpuDet_ExtNestedPaging
  ; - CpuID Level 80000009 -
EndBlankData
; -=- Blank Program Data -=-

; -=- Static Program Data -=-
StartData
  S_Cr db 13, 10, "$"
  Czs S_Log_File, "Probe.log", 0
  Cdse S_Log_Starting, " -=- Starting Probe Log -=-"
  Cdse S_Log_Finished, " -=- Finished Probe Log -=-"

  ; - Scan Level 0 -
  Cdse S_CpuDet_Lev0, " - CPU Detection Start - "
  Cdse S_CpuDet_80888086, "8088/8086 Detected"
  Cdse S_CpuDet_V20V30, "V20/V30 Detected"
  Cdse S_CpuDet_80186, "80186 Detected"
  Cdse S_CpuDet_80286, "80286 Detected"
  Cdse S_CpuDet_80386, "80386 Detected"
  Cdse S_CpuDet_80486, "80486 Detected"
  Cdse S_CpuDet_IdSupport, "CpuID Supported (586+)"
  ; - Scan Level 0 -

  ; - CpuID Level 1 -
  CrsCdse S_CpuDet_VendorString, S_CpuDet_Vendor, "Cpu Vendor: ", "            "
  CrsCdse S_CpuDet_MaxArgString, S_CpuDet_MaxArg, "Max Arguments: ", "             "
  ; - CpuID Level 1 -

  ; - CpuID Level 2 -
  Cdse S_CpuDet_Features, " -=- Features -=- "
  Cds S_CpuDet_Features_Short, "Features: "
  ; - Stepping0-3/Model4-7/Family8-11/Type12-13/ExtModel16-19/ExtFamily20-27 (Eax) -
  Crs S_CpuDet_FMS, "Cpu Family-Model-Stepping: "
    Crs S_CpuDet_Family, "  -"
    CrsCdse S_CpuDet_Model, S_CpuDet_Stepping, "  -", "  "
  Cds S_CpuDet_TypeString, "Cpu Type: "
    Cdse S_CpuDet_Type0, "Primary Processor"
    Cdse S_CpuDet_Type1, "Overdrive Processor"
    Cdse S_CpuDet_Type2, "Secondary Processor"
  Crs S_CpuDet_ExtFM1, "Extended Family-Model: "
    CrsCdse S_CpuDet_ExtFamily1, S_CpuDet_ExtModel1, "  -", "  "
  ; - Stepping0-3/Model4-7/Family8-11/Type12-13/ExtModel16-19/20-27 (Eax) -
  ; - APIC ID31-24/Logical Cpu ID23-16/CFLUSH Chunk Size15-8/BrandID7-0 (Ebx) -
  CrsCdse S_CpuDet_BrandIDString,  S_CpuDet_BrandID,  "Brand ID: ","  "
  CrsCdse S_CpuDet_CFlushString,   S_CpuDet_CFlush,   "CFlush 8-Byte Chunk Count: ","  "
  CrsCdse S_CpuDet_CpuCountString, S_CpuDet_CpuCount, "Cpu Count: ","  "
  CrsCdse S_CpuDet_ApicIDString,   S_CpuDet_ApicID,   "APIC ID: ","  "
  ; - APIC ID31-24/Logical Cpu ID23-16/CFLUSH Chunk Size15-8/BrandID7-0 (Ebx) -
  ; - Features 1 (Ecx) -
  CdsCdse S_CpuDet_Feature1_18_Short, S_CpuDet_Feature1_18, "DCA ", "DCA - Direct Cache Access"
  ; Needs to be Better
  CdsCdse S_CpuDet_Feature1_14_Short, S_CpuDet_Feature1_14, "ETPRD ", "ETPRD - ETPRD"
  CdsCdse S_CpuDet_Feature1_13_Short, S_CpuDet_Feature1_13, "CX16 ", "CX16 - Compare and Exchange 16-Byte"
  CdsCdse S_CpuDet_Feature1_10_Short, S_CpuDet_Feature1_10, "CID - Context ID", "CID "
  CdsCdse S_CpuDet_Feature1_9_Short,  S_CpuDet_Feature1_9,  "S-SSE3 ", "S-SSE3 - Supplemental Streaming SIMD Extension 3"
  CdsCdse S_CpuDet_Feature1_8_Short,  S_CpuDet_Feature1_8,  "TM2 ", "TM2 - Thermal Monitor 2"
  CdsCdse S_CpuDet_Feature1_7_Short,  S_CpuDet_Feature1_7,  "EST ", "EST - Enhanced SpeedStep Technology"
  CdsCdse S_CpuDet_Feature1_6_Short,  S_CpuDet_Feature1_6,  "SMX ", "SMX - Secure Mode Extensions"
  CdsCdse S_CpuDet_Feature1_5_Short,  S_CpuDet_Feature1_5,  "VMX ", "VMX - Vanderpool Technology"
  CdsCdse S_CpuDet_Feature1_4_Short,  S_CpuDet_Feature1_4,  "DSCPL ", "DSCPL - CPL-Qualified Debug Store"
  CdsCdse S_CpuDet_Feature1_3_Short,  S_CpuDet_Feature1_3,  "MON ", "MON - Monitor/MWait"
  CdsCdse S_CpuDet_Feature1_0_Short, S_CpuDet_Feature1_0, "SSE3 ", "SSE3 - Streaming SIMD Extension 3"
  ; - Features 1 (Ecx) -
  ; - Features 2 (Edx) -
  CdsCdse S_CpuDet_Feature2_0_Short, S_CpuDet_Feature2_0, "FPU ", "FPU - Floating Point Unit"
  CdsCdse S_CpuDet_Feature2_1_Short, S_CpuDet_Feature2_1, "VME ", "VME - V86/Virtual Mode Extensions"
  CdsCdse S_CpuDet_Feature2_2_Short, S_CpuDet_Feature2_2, "DE ",  "DE - Debugging Extensions"
  CdsCdse S_CpuDet_Feature2_3_Short, S_CpuDet_Feature2_3, "PSE ", "PSE - Page Size Extensions"
  CdsCdse S_CpuDet_Feature2_4_Short, S_CpuDet_Feature2_4, "TSC ", "TSC - Time Stamp Counter"
  CdsCdse S_CpuDet_Feature2_5_Short, S_CpuDet_Feature2_5, "MSR ", "MSR - Model Specific Registers"
  CdsCdse S_CpuDet_Feature2_6_Short, S_CpuDet_Feature2_6, "PAE ", "PAE - Physical Address Extensions"
  CdsCdse S_CpuDet_Feature2_7_Short, S_CpuDet_Feature2_7, "MCE ", "MCE - Machine Check Exception"
  CdsCdse S_CpuDet_Feature2_8_Short, S_CpuDet_Feature2_8, "CX8 ", "CX8 - Compare and Exchange 8-Byte"
  CdsCdse S_CpuDet_Feature2_9_Short, S_CpuDet_Feature2_9, "APIC ", "APIC - Local APIC On Chip"
  ; Zach: Below Need Seperate Branches 01:58:41 AM 02/01/2007
  ;Cdse S_CpuDet_Feature2_9_AMD_K5_SSA5_Short, S_CpuDet_Feature2_9_AMD_K5_SSA5, "PGE ", "Page Global Extension"
  ;Cds S_CpuDet_Feature2_10_AMD_K6_Model6, "Fast System Call"
  ;Cds S_CpuDet_Feature2_10_Cyrix, "Fast System Calls"
  CdsCdse S_CpuDet_Feature2_11_Short, S_CpuDet_Feature2_11, "SEP ", "SEP - Fast System Call"
  CdsCdse S_CpuDet_Feature2_12_Short, S_CpuDet_Feature2_12, "MTRR ", "MTRR - Memory Type Range Registers"
  CdsCdse S_CpuDet_Feature2_13_Short, S_CpuDet_Feature2_13, "PGE ", "PGE - Page Global Enable"
  CdsCdse S_CpuDet_Feature2_14_Short, S_CpuDet_Feature2_14, "MCA ", "MCA - Machine Check Architecture"
  CdsCdse S_CpuDet_Feature2_15_Short, S_CpuDet_Feature2_15, "CMOV ", "CMOV - Conditional Move Instructions"
  Cdse S_CpuDet_Feature2_16, "PAT - Page Attribute Table"
  Cds S_CpuDet_Feature2_16_Short, "PAT "
  Cdse S_CpuDet_Feature2_17, "PSE36 - 36-Bit Page Size Extenions"
  Cds S_CpuDet_Feature2_17_Short, "PSE36 "
  Cdse S_CpuDet_Feature2_18, "PSN - Processor Serial Number"
  Cds S_CpuDet_Feature2_18_Short, "PSN "
  Cdse S_CpuDet_Feature2_19, "CFLSH - Cache Flush"
  Cds S_CpuDet_Feature2_19_Short, "CFLSH "
  Cdse S_CpuDet_Feature2_21, "DTES - Debug Trace and EMON Store MSRs"
  Cds S_CpuDet_Feature2_21_Short, "DTES "
  Cdse S_CpuDet_Feature2_22, "ACPI - Software Clock Control"
  Cds S_CpuDet_Feature2_22_Short, "ACPI "
  Cdse S_CpuDet_Feature2_23, "MMX - MultiMedia Extensions"
  Cds S_CpuDet_Feature2_23_Short, "MMX "
  Cdse S_CpuDet_Feature2_24, "FXSR - Fast Floating Point Save/Restore"
  Cds S_CpuDet_Feature2_24_Short, "FXSR "
  Cdse S_CpuDet_Feature2_25, "SIMD - Streaming SIMD Extensions"
  Cds S_CpuDet_Feature2_25_Short, "SIMD "
  Cdse S_CpuDet_Feature2_26, "SSE2 - Streaming SIMD Extensions 2"
  Cds S_CpuDet_Feature2_26_Short, "SSE2 "
  Cdse S_CpuDet_Feature2_27, "SELFSNOOP - Self-Snoop"
  Cds S_CpuDet_Feature2_27_Short, "SELFSNOOP "
  Cdse S_CpuDet_Feature2_28, "HTT - Hyper-Threading Technology"
  Cds S_CpuDet_Feature2_28_Short, "HTT "
  Cdse S_CpuDet_Feature2_29, "TM - Thermal Monitor"
  Cds S_CpuDet_Feature2_29_Short, "TM1 "
  Cdse S_CpuDet_Feature2_30, "IA-64 - 64-Bit Intel CPU"
  Cds S_CpuDet_Feature2_30_Short, "IA-64 "
  Cdse S_CpuDet_Feature2_31, "PBE - Pending Break Event"
  Cds S_CpuDet_Feature2_31_Short, "PBE "
  ; - Features 2 (Edx) -
  ; - CpuID Level 2 -

  ; - CpuID Level 3 -
  ; - CpuID Level 3 -

  ; - CpuID Level 4 -
  ; - CpuID Level 4 -

  ; - CpuID Level 5 -
  ; - CpuID Level 5 -

  ; - CpuID Level 6 -
  ; - CpuID Level 6 -

  ; - CpuID Level 7 -
  ; - CpuID Level 7 -

  ; - CpuID Level 80000000 -
  ; - Extended CpuID Count (Eax)
  Crs S_CpuDet_ExtMaxArgString, "Extended CpuID Max Arguments: "
    Cdse S_CpuDet_ExtMaxArg, "             "
  ; - Extended CpuID Count (Eax)
  ; - CpuID Level 80000000 -

  ; - CpuID Level 80000001 -
  Cdse S_CpuDet_ExtFeatures, " -=- Extended Features -=-"
  Cds S_CpuDet_ExtFeatures_Short, "Extended Features: "
  ; - Extended Stepping0-3/Model4-7/Family8-11/ExtModel16-19/ExtFamily20-27 (Eax) -
  Crs S_CpuDet_ExtFMS, "Extended Family-Model-Stepping: "
    Crs S_CpuDet_ExtFamily2, "  -"
    Crs S_CpuDet_ExtModel2, "  -"
    Cdse S_CpuDet_ExtStepping2, "  "
  Crs S_CpuDet_ExtFM2, "Extended Family-Model: "
    Crs S_CpuDet_ExtFamily3, "  -"
    Cdse S_CpuDet_ExtModel3, "  "
  ; - Extended Stepping0-3/Model4-7/Family8-11/ExtModel16-19/ExtFamily20-27 (Eax) -
  ; - Extended Features 1 (Ecx) -
  Cdse S_CpuDet_ExtFeature1_4, "CR8D - MOV From/To CR8D using LOCK-Prefixed MOV From/To CR0"
  Cds S_CpuDet_ExtFeature1_4_Short, "CR8D "
  Cdse S_CpuDet_ExtFeature1_3, "EAS - Extended APIC Space (APIC_VER.EAS EXT_APIC_FEAT Ect.)"
  Cds S_CpuDet_ExtFeature1_3_Short, "EAS "
  Cdse S_CpuDet_ExtFeature1_2, "SVM - Secure Virtual Machine"
  Cds S_CpuDet_ExtFeature1_2_Short, "SVM "
  Cdse S_CpuDet_ExtFeature1_1, "CMP - HTT=1 Indicates HTT(0) Or CMP(1)"
  Cds S_CpuDet_ExtFeature1_1_Short, "CMP "
  Cdse S_CpuDet_ExtFeature1_0, "AHF64 - LAHF And SAHF In PM64"
  Cds S_CpuDet_ExtFeature1_0_Short, "AHF64"
  ; - Extended Features 1 (Ecx) -
  ; - Extended Features 2 (Edx) -
  Cdse S_CpuDet_ExtFeature2_31, "3DNow! - 3DNow!"
  Cds S_CpuDet_ExtFeature2_31_Short, "3DNow! "
  Cdse S_CpuDet_ExtFeature2_30, "3DNow!+ - Extended 3DNow!"
  Cds S_CpuDet_ExtFeature2_30_Short, "3DNow!+ "
  Cdse S_CpuDet_ExtFeature2_29, "LM - AA-64 Long Mode"
  Cds S_CpuDet_ExtFeature2_29_Short, "LM "
  Cdse S_CpuDet_ExtFeature2_27, "TSCP - TSC TSC_AUX RDTSCP CR4.TSD"
  Cds S_CpuDet_ExtFeature2_27_Short, "TSCP "
  Cdse S_CpuDet_ExtFeature2_25, "FFXSR - EFER.FFXSR"
  Cds S_CpuDet_ExtFeature2_25_Short, "FFXSR "
  ;Cdse S_CpuDet_ExtFeature2_24_Cyrix, "MMX+ - Extended MMX"
  ;Cds S_CpuDet_ExtFeature2_24_Cyrix_Short, "MMX+ "
  ;Cdse S_CpuDet_ExtFeature2_24_AMD_K7, "FXSR - FXSAVE/FXRSTOR CR4.OSFXSR"
  ;Cds S_CpuDet_ExtFeature2_24_AMD_K7_Short, "FXSR "
  Cdse S_CpuDet_ExtFeature2_23, "MMX - MMX"
  Cds S_CpuDet_ExtFeature2_23_Short, "MMX "
  Cdse S_CpuDet_ExtFeature2_22, "MMX+ - MMX-SSE and SSE-MEM"
  Cds S_CpuDet_ExtFeature2_22_Short, "MMX+ "
  Cdse S_CpuDet_ExtFeature2_20, "NX - No-Execute Page"
  Cds S_CpuDet_ExtFeature2_20_Short, "NX "
  Cdse S_CpuDet_ExtFeature2_19, "SMP - MP-Capable"
  Cds S_CpuDet_ExtFeature2_19_Short, "SMP "
  Cdse S_CpuDet_ExtFeature2_17, "PSE36 - 36-Bit Page Size Extension"
  Cds S_CpuDet_ExtFeature2_17_Short, "PSE36 "
  Cdse S_CpuDet_ExtFeature2_16, "FCMOV - FCMOVcc/F(U)COMI(P)"
  Cds S_CpuDet_ExtFeature2_16_Short, "FCMOV "
  ;Cdse S_CpuDet_ExtFeature2_16_AMD_K7, "PAT - Page Attribute Table"
  ;Cds S_CpuDet_ExtFeature2_16_AMD_K7_Short, "PAT "
  Cdse S_CpuDet_ExtFeature2_15, "CMOV - Conditionnal Move Instructions"
  Cds S_CpuDet_ExtFeature2_15_Short, "CMOV "
  Cdse S_CpuDet_ExtFeature2_14, "MCA - Machine Check Architecture"
  Cds S_CpuDet_ExtFeature2_14_Short, "MCA "
  Cdse S_CpuDet_ExtFeature2_13, "PGE - Page Global Enable"
  Cds S_CpuDet_ExtFeature2_13_Short, "PGE "
  Cdse S_CpuDet_ExtFeature2_12, "MTRR - Memory Type Range Reg" ; Reg?
  Cds S_CpuDet_ExtFeature2_12_Short, "MTRR "
  Cdse S_CpuDet_ExtFeature2_11, "SEP - Fast System Call"
  Cds S_CpuDet_ExtFeature2_11_Short, "SEP "
  Cdse S_CpuDet_ExtFeature2_9, "APIC - Local APIC Built-in"
  Cds S_CpuDet_ExtFeature2_9_Short, "APIC "
  Cdse S_CpuDet_ExtFeature2_8, "CX8 - Compare and Exchange 8-Byte"
  Cds S_CpuDet_ExtFeature2_8_Short, "CX8 "
  Cdse S_CpuDet_ExtFeature2_7, "MCE - Machine Check Exception"
  Cds S_CpuDet_ExtFeature2_7_Short, "MCE "
  Cdse S_CpuDet_ExtFeature2_6, "PAE - Physical Address Extension"
  Cds S_CpuDet_ExtFeature2_6_Short, "PAE "
  Cdse S_CpuDet_ExtFeature2_5, "MSR - Model Specific Registers"
  Cds S_CpuDet_ExtFeature2_5_Short, "MSR "
  Cdse S_CpuDet_ExtFeature2_4, "TSC - Time Stamp Counter"
  Cds S_CpuDet_ExtFeature2_4_Short, "TSC "
  Cdse S_CpuDet_ExtFeature2_3, "PSE - Page Size Extension"
  Cds S_CpuDet_ExtFeature2_3_Short, "PSE "
  Cdse S_CpuDet_ExtFeature2_2, "DE - Debugging Extensions"
  Cds S_CpuDet_ExtFeature2_2_Short, "DE "
  Cdse S_CpuDet_ExtFeature2_1, "VME - Virtual Mode Extensions"
  Cds S_CpuDet_ExtFeature2_1_Short, "VME "
  Cdse S_CpuDet_ExtFeature2_0, "FPU - Co-Processor Built In"
  Cds S_CpuDet_ExtFeature2_0_Short, "FPU "
  ; - Extended Features 2 (Edx) -
  ; - Brand ID (Ebx) -
  ; - Brand ID (Ebx) -
  ; - CpuID Level 80000001 -

  ; - CpuID Level 80000002/3/4 -
  ; - Extended Cpu Name (Eax/Ebx/Ecx/Edx) -
  Crs S_CpuDet_ExtCpuNameString, "Extended CPU Name: "
    Crs S_CpuDet_ExtCpuName, "                                                "
  ; - Extended Cpu Name (Eax/Ebx/Ecx/Edx) -
  ; - CpuID Level 80000002/3/4 -

  ; - CpuID Level 80000005 -
  ; - CpuID Level 80000005 -

  ; - CpuID Level 80000006 -
  ; - CpuID Level 80000006 -

  ; - CpuID Level 80000007 -
  ; - CpuID Level 80000007 -

  ; - CpuID Level 80000008 -
  ; - CpuID Level 80000008 -

  ; - CpuID Level 8000000A -
  ; - CpuID Level 8000000A -
  ; -=- Static Program Data -=-
EndData

; -=- Start Program -=-
StartProgram
  Dos_DeleteFile S_Log_File, L_Log_DeleteError
 L_Log_Create:
  Dos_CreateFile S_Log_File, Null, V_Log_Handle, L_Log_CreateError
  Log_Print S_Log_Starting

  Call P_CpuDetect

  Log_Print S_Log_Finished
  Dos_CloseFile V_Log_Handle, L_Log_CloseError

  Dos_Exit

 L_Log_DeleteError:
  CompareAndJumpIfEqual Ax, 02h, L_Log_Create
 L_Log_CloseError:
 L_Log_CreateError:
  Dos_Exit 1
; -=- End of Program -=-

; -=- Start of Procedures -=-
 P_CpuDetect Proc
  Log_Print S_CpuDet_Lev0

  ; - Scan Level 0 -
  L_CpuDet_8088:
    Move Cl, 20h, Ax, 1
    ShiftLogicalRight Ax, Cl
    JumpIfRegisterIsNotZero Ax, L_CpuDet_80186
  L_CpuDet_V20:
    MoveZero Al
    Push Cs
    DB 0Fh, 14H, 0C3h ; What is This?
    CompareAndJumpIfNotEqual Al, 0C3h, L_CpuDet_IsV20
      Log_PrintAndReturn S_CpuDet_80888086
  L_CpuDet_IsV20:
    Pop Ax
    Log_PrintAndReturn S_CpuDet_V20V30
  L_CpuDet_80186:
    Move Bx, Sp
    Push Sp
    Pop Ax
    CompareAndJumpIfEqual Ax, Bx, L_CpuDet_80286
      Log_PrintAndReturn S_CpuDet_80186
  L_CpuDet_80286:
    ; Skipped
  L_CpuDet_80386:
    Cli
    PushFD
    Pop Eax
    Move Ebx, Eax
    Xor Eax, 40000h
    Push Eax
    PopFD
    PushFD
    Pop Eax
    Push Ebx
    PopFD
    Sti
    Xor Eax, Ebx
    JumpIfNotZero L_CpuDet_80486
      Log_PrintAndReturn S_CpuDet_80386
  L_CpuDet_80486:
    Cli
    PushFD
    Pop Eax
    Move Ebx, Eax
    Xor Eax, 200000h
    Push Eax
    PopFD
    PushFD
    Pop Eax
    Push Ebx
    PopFD
    Sti
    Xor Eax, Ebx
    JumpIfNotZero L_CpuDet_80586
      Log_PrintAndReturn S_CpuDet_80486
  L_CpuDet_80586:
    Log_Print S_CpuDet_IdSupport
  ; - Scan Level 0 -

  ; - CpuID Level 0 -
   L_CpuDet_Lev0:
    MoveZero Eax
    CpuID
    Move V_CpuDet_Vendor1,Ebx, V_CpuDet_Vendor2,Edx, V_CpuDet_Vendor3,Ecx
    Move DWord Ptr [S_CpuDet_Vendor],Ebx, DWord Ptr [S_CpuDet_Vendor+4],Edx, DWord Ptr [S_CpuDet_Vendor+8],Ecx, V_CpuDet_MaxArg,Eax
    Log_Print S_CpuDet_VendorString
    ConvertDWordToString32 V_CpuDet_MaxArg, S_CpuDet_MaxArg, UseHex
    Log_Print S_CpuDet_MaxArgString
    Move Eax, V_CpuDet_MaxArg
    JumpIfRegisterIsNotZeroElseJump Eax, L_CpuDet_Lev1, L_CpuDet_Exit
  ; - CpuID Level 0 -

  ; - CpuID Level 1 -
   L_CpuDet_Lev1:
    Move Eax, 1
    CpuID
    Move V_CpuDet_TFMS,Eax, V_CpuDet_Feature1,Ecx, V_CpuDet_Feature2,Edx, Eax,Ebx
    MoveFromAhAl V_CpuDet_CFlush,V_CpuDet_BrandID
    SwapWord32 Eax
    MoveFromAhAl V_CpuDet_ApicID, V_CpuDet_CpuCount

    Move Eax, V_CpuDet_TFMS
    And Al, 1111b
    ConvertByteToString Al, S_CpuDet_Stepping, UseHex
    Move Eax, V_CpuDet_TFMS
    ShiftRight4 Al
    And Al, 1111b
    ConvertByteToString Al, S_CpuDet_Model, UseHex
    Move Eax, V_CpuDet_TFMS
    SwapByte16 Ax
    And Al, 1111b
    ConvertByteToString Al, S_CpuDet_Family, UseHex
    Log_Print S_CpuDet_FMS, S_CpuDet_TypeString
    Move Eax, V_CpuDet_TFMS
    ShiftRight12 Al
    And Al, 1111b
    ShiftRightAndJumpIfCarry Al, L_CpuDet_Type_x1
    ShiftRightAndJumpIfCarry Al, L_CpuDet_Type_10
   L_CpuDet_Type_00: Log_PrintAndJump S_CpuDet_Type0, L_CpuDet_Type_Exit
   L_CpuDet_Type_x1: Log_PrintAndJump S_CpuDet_Type1, L_CpuDet_Type_Exit
   L_CpuDet_Type_10: Log_Print S_CpuDet_Type2
   L_CpuDet_Type_Exit:

    Move Eax, V_CpuDet_TFMS
    SwapWord32 Eax
    And Al, 1111b
    ConvertByteToString Al, S_CpuDet_ExtModel1, UseHex
    Move Eax, V_CpuDet_TFMS
    SwapWord32 Eax
    ShiftLeft4 Eax
    ConvertByteToString Al, S_CpuDet_ExtFamily1, UseHex
    Log_Print S_CpuDet_ExtFM1
  
    ConvertByteToString V_CpuDet_BrandID, S_CpuDet_BrandID, UseHex
    ConvertByteToString V_CpuDet_CFlush, S_CpuDet_CFlush, UseHex
    ConvertByteToString V_CpuDet_CpuCount, S_CpuDet_CpuCount, UseHex
    ConvertByteToString V_CpuDet_ApicID, S_CpuDet_ApicID, UseHex
    Log_Print S_CpuDet_BrandIDString, S_CpuDet_CFlushString, S_CpuDet_CpuCountString, S_CpuDet_ApicIDString

    Log_Print S_CpuDet_Features
    Move Ebx, V_CpuDet_Feature1
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature1_0
    ShiftRight2 Ebx
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature1_3, S_CpuDet_Feature1_4, S_CpuDet_Feature1_5, S_CpuDet_Feature1_6
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature1_7, S_CpuDet_Feature1_8, S_CpuDet_Feature1_9, S_CpuDet_Feature1_10
    ShiftRight2 Ebx
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature1_13, S_CpuDet_Feature1_14
    ShiftRight3 Ebx
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature1_18

    Move Ebx, V_CpuDet_Feature2
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature2_0, S_CpuDet_Feature2_1, S_CpuDet_Feature2_2, S_CpuDet_Feature2_3
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature2_4, S_CpuDet_Feature2_5, S_CpuDet_Feature2_6, S_CpuDet_Feature2_7
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature2_8, S_CpuDet_Feature2_9
    ShiftRight1 Ebx
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature2_11, S_CpuDet_Feature2_12, S_CpuDet_Feature2_13, S_CpuDet_Feature2_14
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature2_15, S_CpuDet_Feature2_16, S_CpuDet_Feature2_17, S_CpuDet_Feature2_18
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature2_19
    ShiftRight1 Ebx
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature2_21, S_CpuDet_Feature2_22, S_CpuDet_Feature2_23, S_CpuDet_Feature2_24
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature2_25, S_CpuDet_Feature2_26, S_CpuDet_Feature2_27, S_CpuDet_Feature2_28
    Log_SRAndPSIfSet Ebx, S_CpuDet_Feature2_29, S_CpuDet_Feature2_30, S_CpuDet_Feature2_31
    Log_Print S_Cr

    Move Eax, V_CpuDet_MaxArg
    CompareAndJumpIfAboveElseJump Eax, 1, L_CpuDet_Lev2, L_CpuDet_Lev80000000
  ; - CpuID Level 0 -

  ; - CpuID 2 -
   L_CpuDet_Lev2:
    Move Eax, V_CpuDet_MaxArg
    CompareAndJumpIfAboveElseJump Eax, 2, L_CpuDet_Lev3, L_CpuDet_Lev80000000
  ; - CpuID 2 -

  ; - CpuID 3 -
   L_CpuDet_Lev3:
    Move Eax, V_CpuDet_MaxArg
    CompareAndJumpIfAboveElseJump Eax, 3, L_CpuDet_Lev4, L_CpuDet_Lev80000000
  ; - CpuID 3 -

  ; - CpuID 4 -
   L_CpuDet_Lev4:
    Move Eax, V_CpuDet_MaxArg
    CompareAndJumpIfAboveElseJump Eax, 4, L_CpuDet_Lev5, L_CpuDet_Lev80000000
  ; - CpuID 4 -

  ; - CpuID 5 -
   L_CpuDet_Lev5:
    Move Eax, V_CpuDet_MaxArg
    CompareAndJumpIfAboveElseJump Eax, 5, L_CpuDet_Lev6, L_CpuDet_Lev80000000
  ; - CpuID 5 -

  ; - CpuID 6 -
   L_CpuDet_Lev6:
    ;Move Eax, V_CpuDet_MaxArg
    ;CompareAndJumpIfAbove Eax, 2, L_CpuDet_Lev3
     ;Jump L_CpuDet_Lev80000000
  ; - CpuID 6 -


  ; - CpuID Level 80000000 -
   L_CpuDet_Lev80000000:
    Move Eax, 80000000h
    CpuID
    And Eax, 01111111111111111111111111111111b
    JumpIfRegisterIsZero Eax, L_CpuDet_Exit
    Move V_CpuDet_ExtMaxArg, Eax
    ConvertDWordToString32 V_CpuDet_ExtMaxArg, S_CpuDet_ExtMaxArg, UseHex
    Log_Print S_CpuDet_ExtMaxArgString
  ; - CpuID Level 80000000 -

  ; - CpuID Level 80000001 -
   L_CpuDet_Lev80000001:
    Move Eax, 80000001h
    CpuID
    Move V_CpuDet_ExtFMS,Eax, V_CpuDet_ExtFeature1,Ecx, V_CpuDet_ExtFeature2,Edx

    ; - Zach: Made Software Change 01:05:22 AM 02/01/2007
    ;Move Eax, S_CpuDet_ExtFMS
    SwapByte16 Ax
    And Al, 1111b
    ConvertByteToString Al, S_CpuDet_ExtFamily2, UseHex
    Move Eax, V_CpuDet_ExtFMS
    ShiftRight4 Al
    And Al, 1111b
    ConvertByteToString Al, S_CpuDet_ExtModel2, UseHex
    Move Eax, V_CpuDet_ExtFMS
    And Al, 1111b
    ConvertByteToString Al, S_CpuDet_ExtStepping2, UseHex
    Log_Print S_CpuDet_ExtFMS

    Move Eax, V_CpuDet_ExtFMS
    SwapWord32 Eax
    And Al, 1111b
    ConvertByteToString Al, S_CpuDet_ExtModel3, UseHex
    Move Eax, V_CpuDet_ExtFMS
    SwapWord32 Eax
    ShiftLeft4 Eax
    ConvertByteToString Al, S_CpuDet_ExtFamily3, UseHex
    Log_Print S_CpuDet_ExtFM2

    Log_Print S_CpuDet_ExtFeatures
    Move Ebx, V_CpuDet_ExtFeature2
    Log_SRAndPSIfSet Ebx, S_CpuDet_ExtFeature2_0, S_CpuDet_ExtFeature2_1, S_CpuDet_ExtFeature2_2, S_CpuDet_ExtFeature2_3
    Log_SRAndPSIfSet Ebx, S_CpuDet_ExtFeature2_4, S_CpuDet_ExtFeature2_5, S_CpuDet_ExtFeature2_6, S_CpuDet_ExtFeature2_7
    Log_SRAndPSIfSet Ebx, S_CpuDet_ExtFeature2_8, S_CpuDet_ExtFeature2_9
    ShiftRight1 Ebx
    Log_SRAndPSIfSet Ebx, S_CpuDet_ExtFeature2_11, S_CpuDet_ExtFeature2_12, S_CpuDet_ExtFeature2_13, S_CpuDet_ExtFeature2_14
    ; AMD K-7 Deviant on Bit16
    Log_SRAndPSIfSet Ebx, S_CpuDet_ExtFeature2_15, S_CpuDet_ExtFeature2_16, S_CpuDet_ExtFeature2_17
    ShiftRight1 Ebx
    Log_SRAndPSIfSet Ebx, S_CpuDet_ExtFeature2_19, S_CpuDet_ExtFeature2_20
    ShiftRight1 Ebx
    Log_SRAndPSIfSet Ebx, S_CpuDet_ExtFeature2_22, S_CpuDet_ExtFeature2_23
    ; AMD/Cyrix Deviant on Bit 24
    ShiftRight1 Ebx
    Log_SRAndPSIfSet Ebx, S_CpuDet_ExtFeature2_25
    ShiftRight1 Ebx
    Log_SRAndPSIfSet Ebx, S_CpuDet_ExtFeature2_27
    ShiftRight1 Ebx
    Log_SRAndPSIfSet Ebx, S_CpuDet_ExtFeature2_29, S_CpuDet_ExtFeature2_30, S_CpuDet_ExtFeature2_31

    Move Ebx, V_CpuDet_ExtFeature1
    Log_SRAndPSIfSet Ebx, S_CpuDet_ExtFeature1_0, S_CpuDet_ExtFeature1_1, S_CpuDet_ExtFeature1_2, S_CpuDet_ExtFeature1_3
    Log_SRAndPSIfSet Ebx, S_CpuDet_ExtFeature1_4
    Log_Print S_Cr
    Move Eax, V_CpuDet_ExtMaxArg
    CompareAndJumpIfAboveElseJump Eax, 1, L_CpuDet_Lev80000002, L_CpuDet_Exit
  ; - CpuID Level 80000001 -


  ; - CpuID Level 80000002/3/4 -
   L_CpuDet_Lev80000002:
    Move Eax, 80000002h
    CpuID
    Move V_CpuDet_ExtCpuName1,Eax, V_CpuDet_ExtCpuName2,Ebx, V_CpuDet_ExtCpuName3,Ecx, V_CpuDet_ExtCpuName4,Edx
    Move DWord Ptr [S_CpuDet_ExtCpuName],Eax, DWord Ptr [S_CpuDet_ExtCpuName+4],Ebx, DWord Ptr [S_CpuDet_ExtCpuName+8],Ecx, DWord Ptr [S_CpuDet_ExtCpuName+12],Edx
    Move Eax, 80000003h
    CpuID
    Move V_CpuDet_ExtCpuName5,Eax, V_CpuDet_ExtCpuName6,Ebx, V_CpuDet_ExtCpuName7,Ecx, V_CpuDet_ExtCpuName8,Edx
    Move DWord Ptr [S_CpuDet_ExtCpuName+16],Eax, DWord Ptr [S_CpuDet_ExtCpuName+20],Ebx, DWord Ptr [S_CpuDet_ExtCpuName+24],Ecx, DWord Ptr [S_CpuDet_ExtCpuName+28],Edx
    Move Eax, 80000004h
    CpuID
    Move V_CpuDet_ExtCpuName9,Eax, V_CpuDet_ExtCpuNameA,Ebx, V_CpuDet_ExtCpuNameB,Ecx, V_CpuDet_ExtCpuNameC,Edx
    Move DWord Ptr [S_CpuDet_ExtCpuName+32],Eax, DWord Ptr [S_CpuDet_ExtCpuName+36],Ebx, DWord Ptr [S_CpuDet_ExtCpuName+40],Ecx, DWord Ptr [S_CpuDet_ExtCpuName+44],Edx
    ConvertStringToString16WithCrLf S_CpuDet_ExtCpuName, 0, "$"
    Log_Print S_CpuDet_ExtCpuNameString
  ; - CpuID Level 80000002/3/4 -

  L_CpuDet_Exit:
   Log_PrintAndReturn S_CpuDet_Lev0
 P_CpuDetect EndP

 P_Log_Print Proc
   ;GetStringLength
   MoveZero Bx
   StringLoop:
     Move Al, Ds:[Si+Bx]
     Increase Bx
     CompareAndJumpIfNotEqual Al, "$" ,StringLoop
   Decrease Bx
   Move Cx,Bx, Dx,Si

   ;Dos_WriteFile
   Move V_Log_BufferBytes,Bx, Bx,V_Log_Handle
   MoveAhInt 40h,Dos_Interrupt
   JumpIfCarryNear L_Log_WriteError
   CompareAndJumpIfNotEqual Ax, V_Log_BufferBytes, L_Log_SizeError

   Dos_PrintStringDsDxAndReturn

  L_Log_WriteError:
  L_Log_SizeError:
   Dos_Exit 1
 P_Log_Print EndP
; -=- End of Procedures -=-
EndProgram